<?php

use Shopware\Components\Routing\Router;
use Shopware\Models\Customer\Address;
use Shopware\Models\Customer\Customer;

/**
 * $Id: $
 */
class Mopt_PayonePaymentHelper
{
    //Klarna CDN links for consents and legal terms
    const MOPT_PAYONE_KLARNA_CONSENT_DE = "https://cdn.klarna.com/1.0/shared/content/legal/terms/##storeid##/de_de/consent";
    const MOPT_PAYONE_KLARNA_CONSENT_AT = "https://cdn.klarna.com/1.0/shared/content/legal/terms/##storeid##/de_at/consent";

    const MOPT_PAYONE_KLARNA_INVOICE_TERMS_DE = "https://cdn.klarna.com/1.0/shared/content/legal/terms/##storeid##/de_de/invoice?fee=0";
    const MOPT_PAYONE_KLARNA_INVOICE_TERMS_AT = "https://cdn.klarna.com/1.0/shared/content/legal/terms/##storeid##/de_at/invoice?fee=0";
    const MOPT_PAYONE_KLARNA_INVOICE_TERMS_DK = "https://cdn.klarna.com/1.0/shared/content/legal/terms/##storeid##/da_dk/invoice?fee=0";
    const MOPT_PAYONE_KLARNA_INVOICE_TERMS_FI = "https://cdn.klarna.com/1.0/shared/content/legal/terms/##storeid##/fi_fi/invoice?fee=0";
    const MOPT_PAYONE_KLARNA_INVOICE_TERMS_NL = "https://cdn.klarna.com/1.0/shared/content/legal/terms/##storeid##/nl_nl/invoice?fee=0";
    const MOPT_PAYONE_KLARNA_INVOICE_TERMS_NO = "https://cdn.klarna.com/1.0/shared/content/legal/terms/##storeid##/nb_no/invoice?fee=0";
    const MOPT_PAYONE_KLARNA_INVOICE_TERMS_SE = "https://cdn.klarna.com/1.0/shared/content/legal/terms/##storeid##/sv_se/invoice?fee=0";

    //Payolution links for consents and legal terms
    const MOPT_PAYONE_PAYOLUTION_CONSENT_DE = "https://payment.payolution.com/payolution-payment/infoport/dataprivacydeclaration?mId=";
    const MOPT_PAYONE_PAYOLUTION_SEPA_DE = "https://payment.payolution.com/payolution-payment/infoport/sepa/mandate.pdf";

    /**
     * @var string
     */
    protected $_sFallback = "
        <header>
            <strong>Zusätzliche Hinweise für die Datenschutzerklärung für Kauf auf Rechnung, Ratenzahlung und Zahlung mittels SEPA-Basis-Lastschrift von **company** (im Folgenden: \"wir\")</strong></br>
            <span><i>(Stand: 17.03.2016)</i></span>
        </header>
        <ol>
          <li><p>Bei Kauf auf Rechnung oder Ratenzahlung oder SEPA-Basis-Lastschrift wird von Ihnen während des Bestellprozesses eine datenschutzrechtliche Einwilligung eingeholt. Folgend finden Sie eine Wiederholung dieser Bestimmungen, die lediglich informativen Charakter haben.</p></li>
          <li><p>Bei Auswahl von Kauf auf Rechnung oder Ratenzahlung oder Bezahlung mittels SEPA-Basis-Lastschrift werden für die Abwicklung dieser Zahlarten personenbezogene Daten (Vorname, Nachname, Adresse, Email, Telefonnummer, Geburtsdatum, IP-Adresse, Geschlecht) gemeinsam mit für die Transaktionsabwicklung erforderlichen Daten (Artikel, Rechnungsbetrag, Zinsen, Raten, Fälligkeiten, Gesamtbetrag, Rechnungsnummer, Steuern, Währung, Bestelldatum und Bestellzeitpunkt) an payolution übermittelt werden. payolution hat ein berechtigtes Interesse an den Daten und benötigt bzw. verwendet diese um Risikoüberprüfungen durchzuführen.</p></li>
          <li>
            <p>Zur Überprüfung der Identität bzw. Bonität des Kunden werden Abfragen und Auskünfte bei öffentlich zugänglichen Datenbanken sowie Kreditauskunfteien durchgeführt. Bei nachstehenden Anbietern können Auskünfte und gegebenenfalls Bonitätsinformationen auf Basis mathematisch-statistischer Verfahren eingeholt werden:</p>
            <ul>
                <li>CRIF GmbH, Diefenbachgasse 35, A-1150 Wien</li>
                <li>CRIF AG, Hagenholzstrasse 81, CH-8050 Zürich</li>
                <li>Deltavista GmbH, Dessauerstraße 9, D-80992 München</li>
                <li>SCHUFA Holding AG, Kormoranweg 5, D-65201 Wiesbaden</li>
                <li>KSV1870 Information GmbH, Wagenseilgasse 7, A-1120 Wien</li>
                <li>Bürgel Wirtschaftsinformationen GmbH & Co. KG, Gasstraße 18, D-22761 Hamburg</li>
                <li>Creditreform Boniversum GmbH, Hellersbergstr. 11, D-41460 Neuss</li>
                <li>infoscore Consumer Data GmbH, Rheinstraße 99, D-76532 Baden-Baden</li>
                <li>ProfileAddress Direktmarketing GmbH, Altmannsdorfer Strasse 311, A-1230 Wien</li>
                <li>Deutsche Post Direkt GmbH, Junkersring 57, D-53844 Troisdorf</li>
                <li>payolution GmbH, Am Euro Platz 2, A-1120 Wien</li>
            </ul>
            <p>payolution wird Ihre Angaben zur Bankverbindung (insbesondere Bankleitzahl und Kontonummer) zum Zwecke der Kontonummernprüfung an die SCHUFA Holding AG übermitteln. Die SCHUFA prüft anhand dieser Daten zunächst, ob die von Ihnen gemachten Angaben zur Bankverbindung plausibel sind. Die SCHUFA überprüft, ob die zur Prüfung verwendeten Daten ggf. in Ihrem Datenbestand gespeichert sind und übermittelt sodann das Ergebnis der Überprüfung an payolution zurück. Ein weiterer Datenaustausch wie die Bekanntgabe von Bonitätsinformationen oder eine Übermittlung abweichender Bankverbindungsdaten sowie Speicherung Ihrer Daten im SCHUFA-Datenbestand finden im Rahmen der Kontonummernprüfung nicht statt. Es wird aus Nachweisgründen allein die Tatsache der Überprüfung der Bankverbindungsdaten bei der SCHUFA gespeichert.</p>
            <p>payolution ist berechtigt, auch Daten zu etwaigem nicht-vertragsgemäßen Verhalten (z.B. unbestrittene offene Forderungen) zu speichern, zu verarbeiten, zu nutzen und an oben genannte Auskunfteien zu übermitteln.</p>
          </li>
          <li><p>Wir sind bereits nach den Bestimmungen des Bürgerlichen Gesetzbuches über Finanzierungshilfen zwischen Unternehmern und Verbrauchern, zu einer Prüfung Ihrer Kreditwürdigkeit gesetzlich verpflichtet.</p></li>
          <li><p>Im Fall eines Kaufs auf Rechnung oder Ratenkauf oder einer Bezahlung mittels SEPA-Basis-Lastschrift werden der payolution GmbH Daten über die Aufnahme (zu Ihrer Person, Kaufpreis, Laufzeit des Teilzahlungsgeschäfts, Ratenbeginn) und vereinbarungsgemäße Abwicklung (z.B. vorzeitige Rückzahlung, Laufzeitverlängerung, erfolgte Rückzahlungen) dieses Teilzahlungsgeschäfts übermittelt. Nach Abtretung der Kaufpreisforderung wird die forderungsübernehmende Bank die genannten Datenübermittlungen vornehmen. Wir bzw. die Bank, der die Kaufpreisforderung abgetreten wird, werden payolution GmbH auch Daten aufgrund nichtvertragsgemäßer Abwicklung (z.B. Kündigung des Teilzahlungsgeschäfts, Zwangsvollstreckungs-maßnahmen) melden. Diese Meldungen dürfen nach den datenschutzrechtlichen Bestimmungen nur erfolgen, soweit dies zur Wahrung berechtigter Interessen von Vertragspartnern der payolution GmbH oder der Allgemeinheit erforderlich ist und dadurch Ihre schutzwürdigen Belange nicht beeinträchtigt werden. payolution GmbH speichert die Daten, um ihren Vertragspartnern, die gewerbsmäßig Teilzahlungs- und sonstige Kreditgeschäfte an Verbraucher geben, Informationen zur Beurteilung der Kreditwürdigkeit von Kunden geben zu können. An Unternehmen, die gewerbsmäßig Forderungen einziehen und payolution GmbH vertraglich angeschlossen sind, können zum Zwecke der Schuldnerermittlung Adressdaten übermittelt werden. payolution GmbH stellt die Daten ihren Vertragspartnern nur zur Verfügung, wenn diese ein berechtigtes Interesse an der Datenübermittlung glaubhaft darlegen. payolution GmbH übermittelt nur objektive Daten ohne Angabe der Bank; subjektive Werturteile sowie persönliche Einkommens- und Vermögensverhältnisse sind in Auskünften der payolution GmbH nicht enthalten.</p></li>
          <li><p>Die im Bestellprozess durch Einwilligung erfolgte Zustimmung zur Datenweitergabe kann jederzeit, auch ohne Angabe von Gründen, uns gegenüber widerrufen können. Die oben genannten gesetzlichen Verpflichtungen zur Überprüfung Ihrer Kreditwürdigkeit bleiben von einem allfälligen Widerruf jedoch unberührt. Sie sind verpflichtet ausschließlich wahrheitsgetreue Angaben gegenüber uns zu machen.</p></li>
          <li><p>Sollten Sie Auskunft über die Erhebung, Nutzung, Verarbeitung oder Übermittlung von Sie betreffenden personenbezogenen Daten erhalten wollen oder Auskünfte, Berichtigungen, Sperrungen oder Löschung dieser Daten wünschen, können Sie sich an den Sachbearbeiter für Datenschutz bei payolution wenden:</p></li>
        </ol>

        <footer>Sachbearbeiter für Datenschutz<br />
            datenschutz@payolution.com<br />
            payolution GmbH<br />
            Am Euro Platz 2<br />
            1120 Wien<br />
            DVR: 4008655
        </footer>
    ";


    /**
     * adds Payone API value for creditcard
     *
     * @param array $cardData
     * @return array
     */
    public function mapCardLetter($cardData)
    {
        foreach ($cardData as &$creditCard) {
            $start = strpos($creditCard['name'], 'mopt_payone__cc');

            if ($start === false) {
                continue;
            }

            $creditCardName = substr($creditCard['name'], $start, 19);

            switch ($creditCardName) {
                case "mopt_payone__cc_vis":
                    $creditCard['short'] = 'V';
                    break;
                case 'mopt_payone__cc_mas':
                    $creditCard['short'] = 'M';
                    break;
                case 'mopt_payone__cc_ame':
                    $creditCard['short'] = 'A';
                    break;
                case 'mopt_payone__cc_din':
                    $creditCard['short'] = 'D';
                    break;
                case 'mopt_payone__cc_jcb':
                    $creditCard['short'] = 'J';
                    break;
                case 'mopt_payone__cc_mae':
                    $creditCard['short'] = 'O';
                    break;
                case 'mopt_payone__cc_dis':
                    $creditCard['short'] = 'C';
                    break;
                case 'mopt_payone__cc_car':
                    $creditCard['short'] = 'B';
                    break;
                case 'mopt_payone__cc_chi':
                    $creditCard['short'] = 'P';
                    break;
            }
        }
        return $cardData;
    }

    /**
     * delete saved payment data
     *
     * @param $userId
     * @throws Zend_Db_Adapter_Exception
     */
    public function deletePaymentData($userId)
    {
        if ($userId != null) {
            $sql = 'SELECT userId FROM s_plugin_mopt_payone_payment_data WHERE userId = ' . $userId;
            $result = Shopware()->Db()->fetchOne($sql);
            if ($result) {
                $sql = 'DELETE FROM s_plugin_mopt_payone_payment_data WHERE userId = ' . $userId;
                Shopware()->Db()->exec($sql);
            }
        }
    }

    /**
     * @param $sCompany
     * @return mixed
     */
    protected function _getFallbackText($sCompany)
    {
        $sFallback = str_replace('**company**', $sCompany, $this->_sFallback);
        return $sFallback;
    }

    /**
     * returns payment name
     *
     * @param string $paymentID
     * @return string
     */
    public function getPaymentNameFromId($paymentID)
    {
        $sql = 'SELECT `name` FROM `s_core_paymentmeans` WHERE id = ?';
        $paymentName = Shopware()->Db()->fetchOne($sql, $paymentID);

        return $paymentName;
    }

    /**
     * returns payment name
     *
     * @param string $paymentName
     * @return string
     */
    public function getPaymentIdFromName($paymentName)
    {
        $sql = 'SELECT `id` FROM `s_core_paymentmeans` WHERE name = ?';
        $paymentId = Shopware()->Db()->fetchOne($sql, $paymentName);

        return $paymentId;
    }

    /**
     * save payment data
     *
     * @param $userId
     * @param $paymentData
     * @throws Zend_Db_Adapter_Exception
     */
    public function savePaymentData($userId, $paymentData)
    {
        $sql = 'REPLACE INTO `s_plugin_mopt_payone_payment_data`' .
            '(`userId`,`moptPaymentData`) VALUES (?,?)';
        $paymentData = serialize($paymentData['formData']);
        Shopware()->Db()->query($sql, array($userId, $paymentData));
    }

    /**
     * set configured default payment as payment method
     *
     * @param $userId
     * @throws Zend_Db_Adapter_Exception
     */
    public function setConfiguredDefaultPaymentAsPayment($userId)
    {
        $sql = "UPDATE s_user SET paymentID = ? WHERE id = ?";
        Shopware()->Db()->query($sql, array((int)Shopware()->Config()->Defaultpayment, (int)$userId));
    }

    /**
     * extract clearing data from response object
     *
     * @param object $response
     * @return boolean|array
     */
    public function extractClearingDataFromResponse($response)
    {
        $responseData = $response->toArray();

        if ($responseData['txid']) {
            $responseData['clearing_txid'] = $responseData['txid'];
        }

        foreach ($responseData as $key => $value) {
            if (strpos($key, 'clearing_') === false) {
                unset($responseData[$key]);
            }
        }

        if (empty($responseData)) {
            return false;
        }

        return $responseData;
    }

    /**
     * extract barzahlen code to embed on checkout finish page from response object
     *
     * @param $response
     * @return bool|string
     */
    public function extractBarzahlenCodeFromResponse($response)
    {
        if (!method_exists($response, 'getPaydata')) {
            return false;
        }
        $payData = $response->getPaydata();
        if (!$payData) {
            return false;
        }
        $arr = $payData->toArray();
        foreach ($arr as $k => $v) {
            $arr[substr($k, strpos($k, '[') + 1, -1)] = $v;
        }
        if ($arr['content_format'] === 'HTML') {
            return urldecode($arr['instruction_notes']);
        } else {
            return $arr['instruction_notes'];
        }
    }

    /**
     * extract Payolution Clearingdata on checkout finish page from response object
     *
     * @param object $response
     * @return boolean|array
     */
    public function extractPayolutionClearingDataFromResponse($response)
    {
        if ($response instanceof Payone_Api_Response_Authorization_Approved) {
            $responseData = $response->toArray();

            foreach ($responseData['rawResponse'] as $key => $value) {
                if (strpos($key, 'clearing_') === false) {
                    unset($responseData['rawResponse'][$key]);
                }
            }

            if (empty($responseData['rawResponse'])) {
                return false;
            }
            $responseData['rawResponse']['add_paydata[clearing_reference]'] = $responseData['rawResponse']['clearing_reference'];

            return $responseData['rawResponse'];
        }

        if (!method_exists($response, 'getPaydata')) {
            return;
        }
        $payData = $response->getPaydata();
        if (!$payData) {
            return false;
        }
        $arr = $payData->toArray();

        return ($arr);
    }

    /**
     * returns clearing data
     *
     * @param string $orderId
     * @return array
     * @throws Exception
     */
    public function getClearingDataFromOrderId($orderId)
    {
        $data = array();

        if (!$order = Shopware()->Models()->getRepository('Shopware\Models\Order\Order')->find($orderId)) {
            throw new Exception("Order not found.");
        }

        $attribute = $order->getAttribute();
        $clearingData = $attribute->getMoptPayoneClearingData();
        json_decode($clearingData, $data);

        return $data;
    }

    /**
     * check if given payment name is payone creditcard payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneCreditcard($paymentName)
    {
        return preg_match('#mopt_payone__cc#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone creditcard payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneCreditcardForExport($paymentName)
    {
        if (preg_match('#mopt_payone__cc#', $paymentName) || $paymentName == 'mopt_payone_creditcard') {
            return true;
        } else {
            return false;
        }
    }

    /**
     * check if given payment name is payone creditcard payment not grouped
     * it only checks for real existing payment methods not for virtual method "mopt_payone_creditcard"
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneCreditcardNotGrouped($paymentName)
    {
        return preg_match('#mopt_payone__cc#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone sofortueberweisung payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneSofortuerberweisung($paymentName)
    {
        return preg_match('#mopt_payone__ibt_sofortueberweisung#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone sofortueberweisung payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneBancontact($paymentName)
    {
        return preg_match('#mopt_payone__ibt_bancontact#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone barzahlen payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneBarzahlen($paymentName)
    {
        return preg_match('#mopt_payone__csh_barzahlen#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone giropay payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneGiropay($paymentName)
    {
        return preg_match('#mopt_payone__ibt_giropay#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone eps payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneEPS($paymentName)
    {
        return preg_match('#mopt_payone__ibt_eps#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone post eFinance payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayonePostEFinance($paymentName)
    {
        return preg_match('#mopt_payone__ibt_post_efinance#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone post finance card payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayonePostFinanceCard($paymentName)
    {
        return preg_match('#mopt_payone__ibt_post_finance_card#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone iDeal payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneIDeal($paymentName)
    {
        return preg_match('#mopt_payone__ibt_ideal#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone paypal payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayonePaypal($paymentName)
    {
        return preg_match('#mopt_payone__ewallet_paypal#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone paydirekt payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayonePaydirekt($paymentName)
    {
        return preg_match('/^mopt_payone__ewallet_paydirekt$/', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone paydirekt payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayonePaydirektExpress($paymentName)
    {
        return preg_match('#mopt_payone__ewallet_paydirekt_express#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is a payone ewallet payment method
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isEWallet($paymentName)
    {
        return preg_match('#mopt_payone__ewallet#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone debitnote payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneDebitnote($paymentName)
    {
        return preg_match('#mopt_payone__acc_debitnote#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone invoice payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneInvoice($paymentName)
    {
        return preg_match('#mopt_payone__acc_invoice#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone safe invoice payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneSafeInvoice($paymentName)
    {
        return preg_match('#mopt_payone__acc_payone_safe_invoice#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone pay in advance payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayonePayInAdvance($paymentName)
    {
        return preg_match('#mopt_payone__acc_payinadvance#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone cash on delivery payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneCashOnDelivery($paymentName)
    {
        return preg_match('#mopt_payone__acc_cashondel#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone billsafe payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneBillsafe($paymentName)
    {
        return preg_match('#mopt_payone__fin_billsafe#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is old payone klarna payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneKlarna_old($paymentName)
    {
        return preg_match('#mopt_payone__fin_klarna_old#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is any of the existing payone klarna payment, except Klarna OLD
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneKlarna($paymentName)
    {
        return $this->isPayoneKlarnaInstallments($paymentName)
            || $this->isPayoneKlarnaInvoice($paymentName)
            || $this->isPayoneKlarnaDirectDebit($paymentName);
    }

    /**
     * check if given payment name is the virtual grouped klarna payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneKlarnaGrouped($paymentName)
    {
        return preg_match('#mopt_payone_klarna#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone klarna installments payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneKlarnaInstallments($paymentName)
    {
        return preg_match('#mopt_payone__fin_kis_klarna_installments#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone klarna invoice payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneKlarnaInvoice($paymentName)
    {
        return preg_match('#mopt_payone__fin_kiv_klarna_invoice#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone klarna direct debit payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneKlarnaDirectDebit($paymentName)
    {
        return preg_match('#mopt_payone__fin_kdd_klarna_direct_debit#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone P24 payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneP24($paymentName)
    {
        return preg_match('#mopt_payone__ibt_p24#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone payment method
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayonePaymentMethod($paymentName)
    {
        return preg_match('#mopt_payone__#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone instant bank transfer payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneInstantBankTransfer($paymentName)
    {
        return preg_match('#mopt_payone__ibt#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone finance payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneFinance($paymentName)
    {
        return preg_match('#mopt_payone__fin#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone payolution debitnote payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayonePayolutionDebitNote($paymentName)
    {
        return preg_match('#mopt_payone__fin_payolution_debitnote#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone payolution invoice payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayonePayolutionInvoice($paymentName)
    {
        return preg_match('#mopt_payone__fin_payolution_invoice#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone payolution installment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayonePayolutionInstallment($paymentName)
    {
        return preg_match('#mopt_payone__fin_payolution_installment#', $paymentName) ? true : false;
    }

    /**
     * Determines if given payment is of type ratepay
     *
     * @param $paymentName
     * @return bool
     */
    public function isPayoneRatePay($paymentName) {
        $matchPosition = strpos($paymentName, 'mopt_payone__fin_ratepay');
        $return = ($matchPosition !== false) ? true : false;

        return $return;
    }

    /**
     * check if given payment name is payone ratepay invoice
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneRatepayInvoice($paymentName)
    {
        return preg_match('#mopt_payone__fin_ratepay_invoice#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone ratepay installment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneRatepayInstallment($paymentName)
    {
        return preg_match('#mopt_payone__fin_ratepay_installment#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone ratepay direct debit
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneRatepayDirectDebit($paymentName)
    {
        return preg_match('#mopt_payone__fin_ratepay_direct_debit#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone amazonpay
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneAmazonPay($paymentName)
    {
        return preg_match('#mopt_payone__ewallet_amazon_pay#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone paypal installments
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayonePaypalInstallment($paymentName)
    {
        return preg_match('#mopt_payone__fin_paypal_installment#', $paymentName) ? true : false;
    }

    /**
     * check if given payment name is payone alipay payment
     *
     * @param string $paymentName
     * @return boolean
     */
    public function isPayoneAlipay($paymentName)
    {
        return preg_match('#mopt_payone__ewallet_alipay#', $paymentName) ? true : false;
    }

    /**
     * get online bank transfer type for api communication
     *
     * @param string $paymentName
     * @return string
     */
    public function getOnlineBankTransferTypeFromPaymentName($paymentName)
    {
        if ($this->isPayoneSofortuerberweisung($paymentName)) {
            return Payone_Api_Enum_OnlinebanktransferType::INSTANT_MONEY_TRANSFER;
        }

        if ($this->isPayoneBancontact($paymentName)) {
            return Payone_Api_Enum_OnlinebanktransferType::BANCONTACT;
        }

        if ($this->isPayoneGiropay($paymentName)) {
            return Payone_Api_Enum_OnlinebanktransferType::GIROPAY;
        }

        if ($this->isPayoneEPS($paymentName)) {
            return Payone_Api_Enum_OnlinebanktransferType::EPS_ONLINE_BANK_TRANSFER;
        }

        if ($this->isPayonePostEFinance($paymentName)) {
            return Payone_Api_Enum_OnlinebanktransferType::POSTFINANCE_EFINANCE;
        }

        if ($this->isPayonePostFinanceCard($paymentName)) {
            return Payone_Api_Enum_OnlinebanktransferType::POSTFINANCE_CARD;
        }

        if ($this->isPayoneIDeal($paymentName)) {
            return Payone_Api_Enum_OnlinebanktransferType::IDEAL;
        }

        if ($this->isPayoneP24($paymentName)) {
            return Payone_Api_Enum_OnlinebanktransferType::P24;
        }

        return '';
    }

    public function moptGetCountriesAssignedToPayment($paymentId)
    {
        $sql = 'SELECT s_core_paymentmeans_countries.countryID, s_core_countries.countryname, s_core_countries.countryiso '
            . 'FROM s_core_paymentmeans_countries, s_core_countries '
            . 'WHERE s_core_paymentmeans_countries.paymentID = ? '
            . 'AND s_core_countries.id = s_core_paymentmeans_countries.countryID;';
        $paymentCountries = Shopware()->Db()->fetchAll($sql, $paymentId);

        $shopCountries = Shopware()->Container()->get('modules')->Admin()->sGetCountryList();
        $keys = array_column($shopCountries, 'id');
        $values = array_values($shopCountries);
        $shopCountries = array_combine($keys, $values);
        foreach ($paymentCountries as $index => $paymentCountry) {
            if (array_key_exists($paymentCountry['countryID'], $shopCountries)) {
                $paymentCountries[$index]['countryname'] = $shopCountries[$paymentCountry['countryID']]['countryname'];
            }
        }

        return $paymentCountries;
    }

    public function moptGetShippingCountriesAssignedToPayment($paymentId)
    {
        $sql = 'SELECT s_premium_dispatch_countries.countryID, s_core_countries.countryname, s_core_countries.countryiso '
            . 'FROM s_premium_dispatch_countries, s_core_countries, s_premium_dispatch_paymentmeans '
            . 'WHERE s_premium_dispatch_countries.countryID = s_core_countries.id AND s_premium_dispatch_paymentmeans.paymentID = ? '
            . 'AND s_premium_dispatch_paymentmeans.dispatchID = s_premium_dispatch_countries.dispatchID;';
        $paymentCountries = Shopware()->Db()->fetchAll($sql, $paymentId);

        return $paymentCountries;
    }

    public function moptGetKlarnaAdditionalInformation($country, $storeId)
    {
        $information = array('consent' => '', 'legalTerm' => '');

        switch ($country) {
            case 'DE':
                {
                    $information['consent'] = 'Mit der Übermittlung der für die Abwicklung der gewählten Klarna Zahlungsmethode '
                        . 'und einer Identitäts- und Bonitätsprüfung erforderlichen Daten an Klarna bin ich einverstanden. '
                        . 'Meine <a target="_blank" href="' . self::MOPT_PAYONE_KLARNA_CONSENT_DE . '" '
                        . 'style="text-decoration: underline !important;">Einwilligung</a> '
                        . 'kann ich jederzeit mit Wirkung für die Zukunft widerrufen. Es gelten die AGB des Händlers.';
                    $information['legalTerm'] = 'Weitere Informationen zum Rechnungskauf finden Sie in den '
                        . '<a target="_blank" href="' . self::MOPT_PAYONE_KLARNA_INVOICE_TERMS_DE . '" style="text-decoration: underline !important;">'
                        . 'Rechnungsbedingungen</a>.';
                }
                break;

            case 'AT':
                {
                    $information['consent'] = 'Mit der Übermittlung der für die Abwicklung der gewählten Klarna Zahlungsmethode '
                        . 'und einer Identitäts- und Bonitätsprüfung erforderlichen Daten an Klarna bin ich einverstanden. '
                        . 'Meine <a target="_blank" href="' . self::MOPT_PAYONE_KLARNA_CONSENT_AT . '" '
                        . 'style="text-decoration: underline !important;">Einwilligung</a> '
                        . 'kann ich jederzeit mit Wirkung für die Zukunft widerrufen. Es gelten die AGB des Händlers.';
                    $information['legalTerm'] = 'Weitere Informationen zum Rechnungskauf finden Sie in den '
                        . '<a target="_blank" href="' . self::MOPT_PAYONE_KLARNA_INVOICE_TERMS_AT . '" style="text-decoration: underline !important;">'
                        . 'Rechnungsbedingungen</a>.';
                }
                break;

            case 'DK':
                {
                    $information['legalTerm'] = 'Accept legal terms. '
                        . '<a target="_blank" href="' . self::MOPT_PAYONE_KLARNA_INVOICE_TERMS_DK . '" style="text-decoration: underline !important;">'
                        . 'Vilkår for faktura</a>.';
                }
                break;

            case 'NL':
                {
                    $information['legalTerm'] = 'Accept legal terms. '
                        . '<a target="_blank" href="' . self::MOPT_PAYONE_KLARNA_INVOICE_TERMS_DK . '" style="text-decoration: underline !important;">'
                        . 'Factuurvoorwaarden</a>.';
                }
                break;

            case 'NO':
                {
                    $information['legalTerm'] = 'Accept legal terms. '
                        . '<a target="_blank" href="' . self::MOPT_PAYONE_KLARNA_INVOICE_TERMS_DK . '" style="text-decoration: underline !important;">'
                        . 'Vilkår for faktura</a>.';
                }
                break;

            case 'FI':
                {
                    $information['legalTerm'] = 'Accept legal terms. '
                        . '<a target="_blank" href="' . self::MOPT_PAYONE_KLARNA_INVOICE_TERMS_DK . '" style="text-decoration: underline !important;">'
                        . 'Laskuehdot</a>.';
                }
                break;

            case 'SE':
                {
                    $information['legalTerm'] = 'Accept legal terms. '
                        . '<a target="_blank" href="' . self::MOPT_PAYONE_KLARNA_INVOICE_TERMS_SE . '" style="text-decoration: underline !important;">'
                        . 'Villkor för faktura</a>.';
                }
                break;
        }

        $information['consent'] = str_replace('##storeid##', $storeId, $information['consent']);
        $information['legalTerm'] = str_replace('##storeid##', $storeId, $information['legalTerm']);

        return $information;
    }

    public function moptGetPayolutionAdditionalInformation($country, $companyname)
    {
        $information = array('consentDebit' => '', 'consentInvoice' => '', 'sepaagreement' => '');

        switch ($country) {
            case 'DE':
                {
                    $information['consentDebit'] = 'Mit der Übermittlung der für die Abwicklung des Einkaufs '
                        . 'und einer Identitäts- und Bonitätsprüfung erforderlichen Daten an payolution bin ich einverstanden. '
                        . 'Meine <a href="#" style="float:none; margin:0;" onclick="displayOverlayDebit();return false;">Einwilligung</a> '
                        . 'kann ich jederzeit mit Wirkung für die Zukunft widerrufen.';

                    $information['consentInvoice'] = 'Mit der Übermittlung der für die Abwicklung des Einkaufs '
                        . 'und einer Identitäts- und Bonitätsprüfung erforderlichen Daten an payolution bin ich einverstanden. '
                        . 'Meine <a href="#" style="float:none; margin:0;" onclick="displayOverlayInvoice();return false;">Einwilligung</a> '
                        . 'kann ich jederzeit mit Wirkung für die Zukunft widerrufen.';


                    $information['consentInstallment'] = 'Mit der Übermittlung der für die Abwicklung des Einkaufs '
                        . 'und einer Identitäts- und Bonitätsprüfung erforderlichen Daten an payolution bin ich einverstanden. '
                        . 'Meine <a href="#" style="float:none; margin:0;" onclick="displayOverlayInstallment();return false;">Einwilligung</a> '
                        . 'kann ich jederzeit mit Wirkung für die Zukunft widerrufen.';


                    $information['overlaycontent'] = $this->moptGetPayolutionAcceptanceText($companyname);


                    $information['sepaagreement'] = 'Hiermit erteile ich das <a target="_blank" href="' . self::MOPT_PAYONE_PAYOLUTION_SEPA_DE . '" '
                        . 'style="text-decoration: underline !important;">Sepa-Lastschriftmandat</a> ';

                }
                break;
        }

        return $information;
    }

    public function moptGetRatepayDeviceFingerprint()
    {

        if (!Shopware()->Session()->moptRatepayFingerprint) {
            $userData = Shopware()->Modules()->Admin()->sGetUserData();
            $fingerprint = $userData['billingaddress']['firstname'];
            $fingerprint .= $userData['billingaddress']['lastname'];
            $fingerprint .= microtime();
            $fingerprint = md5($fingerprint);
            Shopware()->Session()->moptRatepayFingerprint = $fingerprint;
        } else {
            $fingerprint = Shopware()->Session()->moptRatepayFingerprint;
        }
        return $fingerprint;
    }

    /**
     * @param string $billingCountry
     * @return mixed
     */
    public function moptGetRatepayConfig($billingCountry)
    {
        $sTable = 's_plugin_mopt_payone_ratepay';
        $currency = Shopware()->Shop()->getCurrency();
        $currencyId = $currency->getId();

        $sQuery = " SELECT
                        shopid
                    FROM
                        {$sTable}
                    WHERE 
                        currency_id = '{$currencyId}' AND
                        country_code_billing = '{$billingCountry}'";
        $sQuery .= " LIMIT 1;";
        $sShopId = Shopware()->Db()->fetchOne($sQuery);
        if ($sShopId) {
            $config = Shopware()->Models()->getRepository('Shopware\CustomModels\MoptPayoneRatepay\MoptPayoneRatepay')->getRatepayConfigByShopId($sShopId);
        }
        return $config;
    }

    protected function _isUtf8EncodingNeeded($sString)
    {
        if (preg_match('!!u', $sString)) {
            // this is utf-8
            return false;
        } else {
            // definitely not utf-8
            return true;
        }
    }

    public function moptGetPayolutionAcceptanceText($companyname)
    {
        $sUrl = self::MOPT_PAYONE_PAYOLUTION_CONSENT_DE . base64_encode($companyname);
        $sContent = file_get_contents($sUrl);
        $sPage = false;
        if (!empty($sContent) && stripos($sContent, 'payolution') !== false && stripos($sContent, '<header>') !== false) {
            //Parse content from HTML-body-tag from the given page
            $sRegex = "#<\s*?body\b[^>]*>(.*?)</body\b[^>]*>#s";
            preg_match($sRegex, $sContent, $aMatches);
            if (is_array($aMatches) && count($aMatches) > 1) {
                $sPage = $aMatches[1];
                //remove everything bevore the <header> tag ( a window.close link which wouldn't work in the given context )
                $sPage = substr($sPage, stripos($sPage, '<header>'));
            }
        }
        if (!$sPage) {
            $sPage = $this->_getFallbackText($companyname);
        }
        if ($this->_isUtf8EncodingNeeded($sPage)) {
            $sPage = utf8_encode($sPage);
        }
        return $sPage;
    }

    public function moptUpdateUserInformation($userId, $paymentData)
    {
        /** @var Customer $user */
        $user = Shopware()->Models()->getRepository('Shopware\Models\Customer\Customer')->find($userId);

        /** @var Address $billing */
        $billing = $user->getDefaultBillingAddress();

        if (isset($paymentData['formData']['mopt_payone__klarna_birthyear'])) {
            $user->setBirthday($paymentData['formData']['mopt_payone__klarna_birthyear']
                . '-' . $paymentData['formData']['mopt_payone__klarna_birthmonth']
                . '-' . $paymentData['formData']['mopt_payone__klarna_birthday']);
            Shopware()->Models()->persist($user);

            $billing->setPhone($paymentData['formData']['mopt_payone__klarna_telephone']);
        }

        if (isset($paymentData['formData']['mopt_payone__payolution_birthdaydate'])) {
            $user->setBirthday($paymentData['formData']['mopt_payone__payolution_birthdaydate']);
            Shopware()->Models()->persist($user);
        }

        if (isset($paymentData['formData']['mopt_payone__ratepay_invoice_birthdaydate'])) {
            $user->setBirthday($paymentData['formData']['mopt_payone__ratepay_invoice_birthdaydate']);
            Shopware()->Models()->persist($user);
        }

        if (isset($paymentData['formData']['mopt_payone__ratepay_invoice_telephone'])) {
            $billing->setPhone($paymentData['formData']['mopt_payone__ratepay_invoice_telephone']);
        }

        if (isset($paymentData['formData']['mopt_payone__klarna_personalId'])) {
            $user->getAttribute()->setMoptPayoneKlarnaPersonalid($paymentData['formData']['mopt_payone__klarna_personalId']);
        }

        if (isset($paymentData['formData']['mopt_payone__ratepay_installment_birthdaydate'])) {
            $user->setBirthday($paymentData['formData']['mopt_payone__ratepay_installment_birthdaydate']);
            Shopware()->Models()->persist($user);
        }

        if (isset($paymentData['formData']['mopt_payone__ratepay_installment_telephone'])) {
            $billing->setPhone($paymentData['formData']['mopt_payone__ratepay_installment_telephone']);
        }

        if (isset($paymentData['formData']['mopt_payone__ratepay_direct_debit_birthdaydate'])) {
            $user->setBirthday($paymentData['formData']['mopt_payone__ratepay_direct_debit_birthdaydate']);
            Shopware()->Models()->persist($user);
        }

        if (isset($paymentData['formData']['mopt_payone__ratepay_direct_debit_telephone'])) {
            $billing->setPhone($paymentData['formData']['mopt_payone__ratepay_direct_debit_telephone']);
        }

        if (isset($paymentData['formData']['mopt_payone__payone_safe_invoice_birthdaydate'])) {
            $user->setBirthday($paymentData['formData']['mopt_payone__payone_safe_invoice_birthdaydate']);
            Shopware()->Models()->persist($user);
        }

        Shopware()->Models()->persist($billing);
        Shopware()->Models()->flush();
    }

    /**
     * retrieve multilang errorcode based on context and errorcode
     *
     * @param string|bool $context
     * @param string|bool $errorCode
     * @return string
     */
    public function moptGetErrorMessageFromErrorCodeViaSnippet($context = false, $errorCode = false)
    {
        $namespace = Shopware()->Snippets()->getNamespace('frontend/MoptPaymentPayone/errorMessages');
        if ($context) {
            $generalErrorMessage = $namespace->get($context . 'ErrorMessage');
        } else {
            $generalErrorMessage = $namespace->get('generalErrorMessage', 'Es ist ein Fehler aufgetreten');
        }

        if ($errorCode) {
            return $namespace->get('errorMessage' . $errorCode, $generalErrorMessage, true);
        } else {
            return $generalErrorMessage;
        }
    }

    /**
     * collect and return predefinded possible creditcard check error messages
     *
     * @return array
     */
    public function getCreditCardCheckErrorMessages()
    {
        $errorMessages = array();
        $namespace = Shopware()->Snippets()->getNamespace('frontend/MoptPaymentPayone/errorMessages');
        $errorMessages['general'] = $namespace->get(
            'creditCardCheckerrorMessage',
            'Bitte überprüfen Sie die Angaben auf der Karte.'
        );
        $errorMessages['CustomExpiry'] = $namespace->get(
            'errorMessageCustomExpiry',
            'Unzureichendes Gültigkeitsdatum. Ihre Kreditkarte unterschreitet die vom Händler hinterlegte Mindestgültigkeit.'
        );
        $errorMessages['33'] = $namespace->get(
            'errorMessage33',
            'Ungültiges Verfallsdatum. Bitte überprüfen Sie die Angaben auf der Karte.'
        );
        $errorMessages['877'] = $namespace->get(
            'errorMessage877',
            'Ungültige Kartennummer. Bitte überprüfen Sie die Angaben auf der Karte.'
        );
        $errorMessages['880'] = $namespace->get(
            'errorMessage880',
            'Kartentyp passt nicht zur Kartennummer. Bitte überprüfen Sie die Angaben auf der Karte.'
        );
        $errorMessages['1041'] = $namespace->get(
            'errorMessage1041',
            'Parameter successurl fehlt oder ist fehlerhaft.'
        );
        $errorMessages['1076'] = $namespace->get(
            'errorMessage1076',
            'Ungültiger Kartentyp. Bitte überprüfen Sie die Angaben auf der Karte.'
        );
        $errorMessages['1077'] = $namespace->get(
            'errorMessage1077',
            'Ungültiges Verfallsdatum. Bitte überprüfen Sie die Angaben auf der Karte.'
        );
        $errorMessages['1078'] = $namespace->get(
            'errorMessage1078',
            'Ungültige Kartennummer. Bitte überprüfen Sie die Angaben auf der Karte.'
        );
        $errorMessages['1079'] = $namespace->get(
            'errorMessage1079',
            'Ungültiges Verfallsdatum. Bitte überprüfen Sie die Angaben auf der Karte.'
        );
        return $errorMessages;
    }

    /**
     * get action name from paymentname
     *
     * @param string $paymentShortName
     * @return string|boolean
     */
    public function getActionFromPaymentName($paymentShortName)
    {
        if ($this->isPayoneCreditcard($paymentShortName)) {
            return 'creditcard';
        }

        if ($this->isPayoneInstantBankTransfer($paymentShortName)) {
            return 'instanttransfer';
        }

        if ($this->isPayonePaypal($paymentShortName)) {
            return 'paypal';
        }

        if ($this->isPayonePaypalInstallment($paymentShortName)) {
            return 'paypalinstallment';
        }

        if ($this->isPayoneDebitnote($paymentShortName)) {
            return 'debitnote';
        }

        if ($this->isPayoneInvoice($paymentShortName) || $this->isPayonePayInAdvance($paymentShortName)) {
            return 'standard';
        }

        if ($this->isPayoneSafeInvoice($paymentShortName)) {
            return 'standard';
        }

        if ($this->isPayoneCashOnDelivery($paymentShortName)) {
            return 'cashondel';
        }

        if ($this->isPayoneKlarna_old($paymentShortName)) {
            return 'klarnaold';
        }

        if ($this->isPayoneKlarnaInstallments($paymentShortName)) {
            return 'klarnainstallments';
        }

        if ($this->isPayoneKlarnaInvoice($paymentShortName)) {
            return 'klarnainvoice';
        }

        if ($this->isPayoneKlarnaDirectDebit($paymentShortName)) {
            return 'klarnadirectdebit';
        }

        if ($this->isPayonePayolutionDebitNote($paymentShortName)) {
            return 'payolutiondebit';
        }

        if ($this->isPayonePayolutionInvoice($paymentShortName)) {
            return 'payolutioninvoice';
        }

        if ($this->isPayonePayolutionInstallment($paymentShortName)) {
            return 'payolutioninstallment';
        }

        if ($this->isPayoneRatepayInvoice($paymentShortName)) {
            return 'ratepayinvoice';
        }

        if ($this->isPayoneRatepayInstallment($paymentShortName)) {
            return 'ratepayinstallment';
        }

        if ($this->isPayoneRatepayDirectDebit($paymentShortName)) {
            return 'ratepaydirectdebit';
        }

        if ($this->isPayoneFinance($paymentShortName)) {
            return 'finance';
        }

        if ($this->isPayoneBarzahlen($paymentShortName)) {
            return 'barzahlen';
        }

        if ($this->isPayonePaydirektExpress($paymentShortName)) {
            return 'paydirektexpress';
        }
        if ($this->isPayonePaydirekt($paymentShortName)) {
            return 'paydirekt';
        }
        if ($this->isPayoneAlipay($paymentShortName)) {
            return 'alipay';
        }
        return false;
    }

    /**
     * check if current payment method is paypal and paypal ecs is activated
     *
     * @param Mopt_PayoneMain $payoneMain
     * @param array $paymentMethod
     * @return boolean
     */
    public function isPayPalEcsActive($payoneMain, $paymentMethod)
    {
        if (!$this->isPayonePaypal($paymentMethod['name'])) {
            return false;
        }

        $config = $payoneMain->getPayoneConfig($paymentMethod['id']);
        return (bool)$config['paypalEcsActive'];
    }

    /**
     * checks if PayDirektExpress is enabled
     *
     * @return bool
     */
    public function isPaydirektExpressActive()
    {
        $paymentPayDirektExpress = Shopware()->Models()->getRepository('Shopware\Models\Payment\Payment')->findOneBy(
            ['name' => 'mopt_payone__ewallet_paydirekt_express']
        );
        return $paymentPayDirektExpress->getActive();
    }

    /**
     * group credit cards to single payment method creditcard
     *
     * @param array $paymentMeans
     * @return bool|array
     */
    public function groupCreditcards($paymentMeans)
    {
        $firstHit = 'not_set';
        $creditCardData = array();
        $shortCodes = array (
            'mopt_payone__cc_visa' => 'v',
            'mopt_payone__cc_mastercard' => 'm',
            'mopt_payone__cc_american_express' => 'a',
            'mopt_payone__cc_carte_blue' => 'b',
            'mopt_payone__cc_diners_club' => 'd',
            'mopt_payone__cc_jcb' => 'j',
            'mopt_payone__cc_maestro_international' => 'o',
        );

        foreach ($paymentMeans as $key => $paymentmean) {
            if ($this->isPayoneCreditcardNotGrouped($paymentmean['name'])) {
                if ($firstHit === 'not_set') {
                    $firstHit = $key;
                }

                $creditCard = array();
                $creditCard['id'] = $paymentmean['id'];
                $creditCard['name'] = $paymentmean['name'];
                $creditCard['description'] = $paymentmean['description'];

                $creditCardData[] = $creditCard;
                $creditCardDescriptions[$creditCard['name']] = '<div class="payone_additionalDescriptions" id="' . $shortCodes[$creditCard['name']]  . '_additionalDescription" style="display:none">' . $paymentmean['additionaldescription'] . '</div>';

                if ($firstHit != $key) {
                    unset($paymentMeans[$key]);
                }
            }
        }

        // don't assign anything if no creditcard was found
        if ($firstHit === 'not_set') {
            return false;
        }

        $snippetObject = Shopware()->Snippets()->getNamespace('frontend/MoptPaymentPayone/payment');
        $paymentMeans[$firstHit]['id'] = 'mopt_payone_creditcard';
        $paymentMeans[$firstHit]['name'] = 'mopt_payone_creditcard';
        $paymentMeans[$firstHit]['description'] = $snippetObject->get('PaymentMethodCreditCard', 'Kreditkarte', true);
        $paymentMeans[$firstHit]['mopt_payone_credit_cards'] = $creditCardData;
        $paymentMeans[$firstHit]['additionaldescription'] = implode('',$creditCardDescriptions);

        return $paymentMeans;
    }

    /**
     * group Klarna payments to single payment method Klarna, except Klarna OLD
     *
     * @param array $paymentMeans
     * @return array
     */
    public function groupKlarnaPayments($paymentMeans)
    {
        $snippetObject = Shopware()->Snippets()->getNamespace('frontend/MoptPaymentPayone/payment');
        $paymentGroupData = [
            'id' => 'mopt_payone_klarna',
            'name' => 'mopt_payone_klarna',
            'description' => $snippetObject->get('PaymentMethodKlarna', 'PAYONE Klarna Payments', true),
            'key' => 'mopt_payone_klarna_payments',
        ];

        return $this->groupPayments(array($this, 'isPayoneKlarna'), $paymentMeans, $paymentGroupData);
    }

    /**
     * group payment methods to single payment method
     *
     * @param callable $paymentCheckCallback callback, to check a payment, whether it belongs to a defined group of payments
     * @param array    $paymentMeans
     * @param array    $paymentGroupData an array with an id, a name, a description and a key
     *
     * @return array
     */
    protected function groupPayments($paymentCheckCallback, $paymentMeans, $paymentGroupData)
    {
        $firstHit = 'not_set';
        $payments = array();

        foreach ($paymentMeans as $key => $paymentmean) {
            if ($paymentCheckCallback($paymentmean['name'])) {
                if ($firstHit === 'not_set') {
                    $firstHit = $key;
                }

                $payment = array();
                $payment['id'] = $paymentmean['id'];
                $payment['name'] = $paymentmean['name'];
                $payment['description'] = $paymentmean['description'];

                $payments[] = $payment;

                if ($firstHit != $key) {
                    unset($paymentMeans[$key]);
                }
            }
        }

        // don't assign anything if no payment to be grouped was found
        if ($firstHit === 'not_set') {
            return $paymentMeans;
        }

        $paymentMeans[$firstHit]['id'] = $paymentGroupData['id'];
        $paymentMeans[$firstHit]['name'] = $paymentGroupData['name'];
        $paymentMeans[$firstHit]['description'] = $paymentGroupData['description'];
        $paymentMeans[$firstHit][$paymentGroupData['key']] = $payments;

        return $paymentMeans;
    }

    /**
     * Returns the Klarna name by financingtype
     *
     * @param $financingtype
     *
     * @return string
     */
    public function getKlarnaNameByFinancingtype($financingtype)
    {
        return array_search($financingtype, $this->klarnaPaymentFinancingtypeNameMapping());
    }

    /**
     * Returns the Klarna financingtype by name
     *
     * @param $paymentName
     *
     * @return string
     */
    public function getKlarnaFinancingtypeByName($paymentName)
    {
        return $this->klarnaPaymentFinancingtypeNameMapping()[$paymentName];
    }

    /**
     * Maps Payone API value for Klarna
     *
     * @return string[]
     */
    private function klarnaPaymentFinancingtypeNameMapping()
    {
        return [
            'mopt_payone__fin_kis_klarna_installments' => Payone_Api_Enum_FinancingType::KIS,
            'mopt_payone__fin_kiv_klarna_invoice' => Payone_Api_Enum_FinancingType::KIV,
            'mopt_payone__fin_kdd_klarna_direct_debit' => Payone_Api_Enum_FinancingType::KDD,
        ];
    }

    /**
     * Fetches and returns amazon payment instance.
     *
     * @return \Shopware\Models\Payment\Payment
     */
    public function getPaymentPaydirektExpress()
    {
        $paymentPaydirektexpress = Shopware()->Models()->getRepository('Shopware\Models\Payment\Payment')->findOneBy(
            ['name' => 'mopt_payone__ewallet_paydirekt_express']
        );
        return $paymentPaydirektexpress;
    }

    /**
     * Fetches and returns amazon payment instance.
     *
     * @return \Shopware\Models\Payment\Payment
     */
    public function getPaymentAmazonPay()
    {
        $paymentAmazonPay = Shopware()->Models()->getRepository('Shopware\Models\Payment\Payment')->findOneBy(
            ['name' => 'mopt_payone__ewallet_amazon_pay']
        );
        return $paymentAmazonPay;
    }

    /**
     * checks if AmazonPay is active
     *
     * @return bool
     */
    public function isAmazonPayActive($paymentMethod)
    {
        if (!$this->isPayoneAmazonPay($paymentMethod['name'])) {
            return false;
        } else {
            return true;
	    }
    }

    /**
     * checks if AmazonPay is enabled
     *
     * @return bool
     */
    public function isAmazonPayEnabled()
    {
        $paymentAmazonPay = Shopware()->Models()->getRepository('Shopware\Models\Payment\Payment')->findOneBy(
            ['name' => 'mopt_payone__ewallet_amazon_pay']
        );
        return $paymentAmazonPay->getActive();
    }


    /**
     * Marks all OrderDetails and Shipping as Fully Captured
     *
     * @param Shopware\Models\Order\Order $order shopware order object
     *
     * @return void
     * @throws Exception
     */
    public function markOrderDetailsAsFullyCaptured($order)
    {
        foreach ($order->getDetails() as $position) {
            $positionAttribute = $position->getAttribute();
            $positionAttribute->setMoptPayoneCaptured($position->getPrice() * $position->getQuantity());
            Shopware()->Models()->persist($positionAttribute);
        }
        Shopware()->Models()->flush();
        $orderAttribute = $order->getAttribute();
        $orderAttribute->setMoptPayoneShipCaptured($order->getInvoiceShipping());
        Shopware()->Models()->persist($orderAttribute);
        Shopware()->Models()->flush();
    }

    /**
     * @param Router $router
     * @param $userParams
     * @param null $context
     * @return false|string
     */
    public function assembleTokenizedUrl($router, $userParams, $context = null) {
        if(version_compare(Shopware()->Config()->get('version'), '5.6.3', '>='))
        {
            /** @noinspection PhpFullyQualifiedNameUsageInspection */
            $token = Shopware()->Container()->get(\Shopware\Components\Cart\PaymentTokenService::class)->generate();
            /** @noinspection PhpFullyQualifiedNameUsageInspection */
            $this->array_splice_assoc($userParams, -1, 0, array(\Shopware\Components\Cart\PaymentTokenService::TYPE_PAYMENT_TOKEN => $token));
            return $router->assemble(
                $userParams
                , $context);
        }

        return $router->assemble($userParams, $context);
    }

    function array_splice_assoc(&$input, $offset, $length, $replacement = array()) {
        $replacement = (array) $replacement;
        $key_indices = array_flip(array_keys($input));
        if (isset($input[$offset]) && is_string($offset)) {
            $offset = $key_indices[$offset];
        }
        if (isset($input[$length]) && is_string($length)) {
            $length = $key_indices[$length] - $offset;
        }

        $input = array_slice($input, 0, $offset, TRUE)
            + $replacement
            + array_slice($input, $offset + $length, NULL, TRUE);
    }

    public function buildAndCallKlarnaStartSession($paymentFinancingtype, $birthdate, $phoneNumber, $personalId)
    {
        $bootstrap = Shopware()->Container()->get('plugins')->Frontend()->MoptPaymentPayone();

        $userData = Shopware()->Modules()->Admin()->sGetUserData();

        /** @var Mopt_PayoneMain $moptPayoneMain */
        $moptPayoneMain = $bootstrap->Application()->MoptPayoneMain();
        $paramBuilder = $moptPayoneMain->getParamBuilder();
        $basket = $moptPayoneMain->sGetBasket();

        /** @var Payone_Builder $payoneBuilder */
        $payoneBuilder = $bootstrap->Application()->MoptPayoneBuilder();
        $service = $payoneBuilder->buildServicePaymentGenericpayment();

        $repositoryNamespace = 'Shopware\CustomModels\MoptPayoneApiLog\MoptPayoneApiLog';
        /** @var Payone_Api_Persistence_Interface $moptPayoneApiLogRepository */
        $moptPayoneApiLogRepository = Shopware()->Models()->getRepository($repositoryNamespace);
        $service->getServiceProtocol()->addRepository($moptPayoneApiLogRepository);

        $userData['additional']['user']['birthday'] = $birthdate;
        $userData['additional']['user']['mopt_payone_klarna_personalid'] = $personalId;
        Shopware()->Session()->offsetSet('mopt_klarna_phoneNumber', $phoneNumber);

        $shippingCosts = Shopware()->Modules()->Admin()->sGetPremiumShippingcosts();

        $params = $paramBuilder->buildKlarnaSessionStartParams('fnc', $paymentFinancingtype, $basket, $shippingCosts);
        $request = new Payone_Api_Request_Genericpayment($params);

        $basket['sShippingcosts'] = $shippingCosts['brutto'];
        $basket['sShippingcostsWithTax'] = $shippingCosts['brutto'];
        $basket['sShippingcostsNet'] = $shippingCosts['netto'];
        $basket['sShippingcostsTax'] = $shippingCosts['tax'];

        $personalData = $paramBuilder->getPersonalData($userData);
        $request->setPersonalData($personalData);
        $deliveryData = $paramBuilder->getDeliveryData($userData);
        $request->setDeliveryData($deliveryData);

        $selectedDispatchId = Shopware()->Session()['sDispatch'];
        $dispatch = Shopware()->Modules()->Admin()->sGetPremiumDispatch($selectedDispatchId);

        $invoicing = $paramBuilder->getInvoicing($basket, $dispatch, $userData);
        $request->setInvoicing($invoicing);

        $result = null;

        try {
            $result = $service->request($request);
        } catch (Exception $e) {
        }

        return $result;
    }

    public function getKlarnaGender($userData) {
        $salutation = $userData['additional']['user']['salutation'];

        return $salutation === 'mr' ? 'male' : 'female';
    }

    public function getKlarnaTitle($userData) {
        $countryIso2 = $userData['additional']['country']['countryiso'];
        $salutation = $userData['additional']['user']['salutation'];
        switch ($countryIso2) {
            case 'AT':
            case 'DE':
            case 'CH':
                $title = ($salutation === 'mr') ? 'Herr' : 'Frau';
                break;
            case 'GB':
            case 'US':
                $title = ($salutation === 'mr') ? 'Mr' : 'Ms';
                break;
            case 'DK':
            case 'FI':
            case 'SE':
            case 'NL':
            case 'NO':
                $title = ($salutation === 'mr') ? 'Dhr.' : 'Mevr.';
                break;
            default:
                $title = '';
        }

        return $title;
    }

    /**
     * Check if birthday field needs to be shown
     *
     * @return bool
     */
    public function isKlarnaBirthdayNeeded()
    {
        $isBirthdayValid = $this->isBirthdayValid();
        $isBirthdayNeededByCountry = $this->isKlarnaBirthdayNeededByCountry();

        return !$isBirthdayValid && $isBirthdayNeededByCountry;
    }

    /**
     * Check if telephone field needs to be shown
     *
     * @return bool
     */
    public function isKlarnaTelephoneNeeded()
    {
        $isTelephoneValid = $this->isTelephoneValid();
        $isTelephoneNeededByCountry = $this->isKlarnaTelephoneNeededByCountry();

        return !$isTelephoneValid && $isTelephoneNeededByCountry;
    }

    /**
     * Check if telephone field needs to be shown
     *
     * @return bool
     */
    public function isKlarnaPersonalIdNeeded()
    {
        $isPersonalIdValid = $this->isPersonalIdValid();
        $isPersonalIdNeededByCountry = $this->isKlarnaPersonalIdNeededByCountry();

        return !$isPersonalIdValid && $isPersonalIdNeededByCountry;
    }

    /**
     * Checks if current users birthday is valid
     *
     * @return bool
     */
    private function isBirthdayValid()
    {
        $userData = Shopware()->Modules()->Admin()->sGetUserData();

        return !is_null($userData['additional']['user']['birthday']) && $userData['additional']['user']['birthday'] !== '' && $userData['additional']['user']['birthday'] !== '0000-00-00';
    }

    /**
     * Checks if current users telephone number is valid
     *
     * @return bool
     */
    private function isTelephoneValid()
    {
        $userData = Shopware()->Modules()->Admin()->sGetUserData();

        return !is_null($userData['billingaddress']['phone']) && $userData['billingaddress']['phone'] !== '';
    }

    /**
     * Checks if current users personalid number is valid
     *
     * @return bool
     */
    private function isPersonalIdValid()
    {
        $userData = Shopware()->Modules()->Admin()->sGetUserData();

        return !is_null($userData['additional']['user']['mopt_payone_klarna_personalid']) && $userData['additional']['user']['mopt_payone_klarna_personalid'] !== '';
    }

    /**
     * Checks if birthday is mandatory for klarna payments depending on country
     *
     * @return bool
     */
    private function isKlarnaBirthdayNeededByCountry()
    {
        $moptPayoneHelper = Shopware()->Container()->get('MoptPayoneMain')->getInstance()->getHelper();
        $userData = Shopware()->Modules()->Admin()->sGetUserData();
        $billingCountryIso = $moptPayoneHelper->getCountryIsoFromId($userData['billingaddress']['countryID']);
        $klarnaBirthdayNeededCountries = array('DE', 'NL', 'AT', 'CH');
        return in_array($billingCountryIso, $klarnaBirthdayNeededCountries);
    }

    /**
     * Checks if telephone is mandatory for klarna payments depending on country
     *
     * @return bool
     */
    public function isKlarnaTelephoneNeededByCountry()
    {
        $moptPayoneHelper = Shopware()->Container()->get('MoptPayoneMain')->getInstance()->getHelper();
        $userData = Shopware()->Modules()->Admin()->sGetUserData();
        $billingCountryIso = $moptPayoneHelper->getCountryIsoFromId($userData['billingaddress']['countryID']);
        $klarnaTelephoneNeededCountries = array('NO', 'SE', 'DK');
        return in_array($billingCountryIso, $klarnaTelephoneNeededCountries);
    }

    /**
     * Checks if personalid is mandatory for klarna payments depending on country
     *
     * @return bool
     */
    public function isKlarnaPersonalIdNeededByCountry()
    {
        $moptPayoneHelper = Shopware()->Container()->get('MoptPayoneMain')->getInstance()->getHelper();
        $userData = Shopware()->Modules()->Admin()->sGetUserData();
        $billingCountryIso = $moptPayoneHelper->getCountryIsoFromId($userData['billingaddress']['countryID']);
        $klarnaPersonalIdNeededCountries = array('NO', 'SE', 'DK'); // SE verified FI unsure
        return in_array($billingCountryIso, $klarnaPersonalIdNeededCountries);
    }
}
